{

6502 core test env.

Configured for 96Mhz HYBRID board.  Nothing requires this however, so edit for your setup.  (Done in TV Driver)

All that's provided here right now is a STRING compatable font, Text Display Driver, Screen Buffer, Pointers to things


}

CON
  ' Set up the processor clock in the standard way for 80MHz on HYBRID
  ' You will want to edit this to reflect your clock setup
  ' Also necessary is editing the pin definitions, and that's done in the driver itself.
_CLKMODE = xtal1 + pll16x
_XINFREQ = 6_000_000 + 0000

VAR
  'byte          displayb[1024]   'allocate display buffer in HUB RAM  40x24 probably not a good idea to have dynamic screen
                                  'right now, so it's gonna be at the TOP of HUB ram. 
  word          displayb
  
  'byte          r6502_Program[1024]  '1K of 6502 code space for now   Same for program space!

  word          r6502_program

  
  long          index            'just an index...
  long          fonttab          'pointer to HUB Font Table
  long          params[4]                                    'The address of this array gets 
                '[0] screen memory                            passed to the TV driver.
                '[1] font table
                '[2] pix_mode not yet implemented...
                '[3] colors, or 16 bit mode = $00
  
OBJ
  tv : "8x8_NTSC_40x24_TV"        'the actual TV display driver
  font : "Font_ATARI"             'a font table!  Actually, this uses the AIGeneric system for font files!
 
PUB start |  Temp

    init_pointers
    locate_code(00)               'not sure how this is gonna get done.
    init_display
    clear_screen

    print_xy(4,1, @welcome)   'Let somebody know what the heck is going on!
   

{we do stuff here with the emulated CPU...}




PUB  init_pointers

     displayb := $7bff                'top of HUB - ~1Kb for display
     r6502_program := $6000           '6502 below screen for now
                                      'don't want to fight relocatable code right now...

PUB  locate_code(length)

     'just a stub right now




PUB  init_display

    params[0] := displayb                               'HUB Address of Text Display Buffer
    params[1] := font.GetPtrToFontTable                 'HUB Address of font table used by TV display  ATASCII for now...
    params[2] := $0000_0000                             'Not implemented....  
    params[3] := $0000502                               'Text display colors (Black and White default)

    tv.start(@params)                                   'start the tv cog & pass it the parameter block
      
PUB  clear_screen | c

    c := 32
    repeat index from 0 to 1024
       byte [displayb] [index] := c                     'clear the screen


PRI  print_xy (x, y, str_addr) | i
     'brutally simple print routine
     'no clipping, no wrap around, no formatting, no nothing
     i := 0
     i := i + x + (y * 40)
     bytemove (displayb + i, str_addr, strsize(str_addr))

    

DAT

Welcome  Byte "6502 Testing in Progress...", 0


DAT

test_program file "code.dat"


























   